import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.border.EtchedBorder;

public class Documentation extends JPanel implements HyperlinkListener {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private URL url;
	private JEditorPane jep;

	private static final String tutorialPath = ".\\Tutorial.html";

/****************************************************************/
/*	Constructors												*/
/****************************************************************/

	public Documentation() {
		try {
			try {
				url = getClass().getResource( tutorialPath );
			}
			catch( Exception e ) {
				JOptionPane.showMessageDialog( null, "Failed to open " + tutorialPath );
			}

			if ( url != null ) {
				jep = new JEditorPane( url );
				jep.setEditable( false );
				jep.addHyperlinkListener( this );
			}

			JScrollPane jsp = new JScrollPane();
			JViewport jvp = jsp.getViewport();
			jvp.add( jep );

			this.setBorder( new EtchedBorder() );
			this.setLayout( new BorderLayout() );
			this.add( jsp, BorderLayout.CENTER );
		}
		catch( MalformedURLException mue ) {
			JOptionPane.showMessageDialog( null, "Malformed URL: " + mue );
		}
		catch( IOException ioe ) {
			JOptionPane.showMessageDialog( null, "IO exception occurred. " );
		}
    }

/****************************************************************/
/*	Hyperlink Listener											*/
/****************************************************************/

	public void hyperlinkUpdate( HyperlinkEvent he ) {

		if ( he.getEventType() == HyperlinkEvent.EventType.ACTIVATED ) {
			if ( he instanceof HTMLFrameHyperlinkEvent ) {
				( ( HTMLDocument ) jep.getDocument() ).processHTMLFrameHyperlinkEvent(
					( HTMLFrameHyperlinkEvent ) he );
			}
			else {
				try {
					jep.setPage( he.getURL() );
				}
				catch( IOException ioe ) {
					JOptionPane.showMessageDialog( null, "IO exception occurred." );
				}
			}
		}
	}
}