import java.io.Serializable;
import java.awt.Color;
import java.awt.Point;
import java.awt.Rectangle;

public class Grenade implements Serializable {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private int spread, id;
	private String grenadeSource;
	private Color grenadeColor;
	private Point location;
	private Rectangle boundingBox;

/****************************************************************/
/*	Constructors												*/
/****************************************************************/

	public Grenade( String s ) {
		grenadeSource = s;
		spread = calculateSpread( grenadeSource );
		grenadeColor = calculateColor( grenadeSource );
		id = Application.generateId();
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	public void setBoundingBox( Rectangle r ) {
		boundingBox = r;
	}

	public void setLocation( Point p ) {
		location = p;
	}

	public void setSpread( int i ) {
		spread = i;
	}

	public void setName( String s ) {
		grenadeSource = s;
	}

	public void setColor( Color c ) {
		grenadeColor = c;
	}

	public String getName() {
		return grenadeSource;
	}

	public int getSpread() {
		return spread;
	}

	public Color getColor() {
		return grenadeColor;
	}

	public Rectangle getBoundingBox() {
		return boundingBox;
	}

	public Point getLocation() {
		return location;
	}

	public int getId() {
		return id;
	}

/****************************************************************/
/*	Methods														*/
/****************************************************************/

	public static int calculateSpread( String s ) {
		int result = 0;

		if ( s.equalsIgnoreCase( "summon swarm" ) | s.equalsIgnoreCase( "tenser's floating disk" ) ) {
			result = 0;
		}
		else if ( s.equalsIgnoreCase( "alchemist's fire" ) | s.equalsIgnoreCase( "holy water" ) |
			 	  s.equalsIgnoreCase( "acid, flask" ) | s.equalsIgnoreCase( "faerie fire" ) |
			 	  s.equalsIgnoreCase( "shatter" ) | s.equalsIgnoreCase( "teleportation circle" ) ) {
			result = 1;
		}
		else if ( s.equalsIgnoreCase( "stonetar" ) | s.equalsIgnoreCase( "avienna's fog" ) |
				  s.equalsIgnoreCase( "thunderstone" ) | s.equalsIgnoreCase( "tanglefoot bag" ) |
				  s.equalsIgnoreCase( "antilife shell" ) | s.equalsIgnoreCase( "antimagic field" ) |
				  s.equalsIgnoreCase( "antiplant shell" ) | s.equalsIgnoreCase( "flame strike" ) |
				  s.equalsIgnoreCase( "invisibility sphere" ) | s.equalsIgnoreCase( "repel vermin" ) |
				  s.equalsIgnoreCase( "magic circle against ..." ) |
				  s.equalsIgnoreCase( "mind fog" ) | s.equalsIgnoreCase( "prismatic sphere" ) |
				  s.equalsIgnoreCase( "otiluke's freezing sphere" ) |
				  s.equalsIgnoreCase( "sound burst" ) ) {
			result = 2;
		}
		else if ( s.equalsIgnoreCase( "sleep" ) | s.equalsIgnoreCase( "acid fog" ) |
				  s.equalsIgnoreCase( "cloudkill" ) | s.equalsIgnoreCase( "confusion" ) |
				  s.equalsIgnoreCase( "incendiary cloud" ) | s.equalsIgnoreCase( "obscuring mist" ) |
				  s.equalsIgnoreCase( "rainbow pattern" ) | s.equalsIgnoreCase( "scare" ) |
				  s.equalsIgnoreCase( "silence" ) ) {
			result = 3;
		}
		else if ( s.equalsIgnoreCase( "fireball" ) | s.equalsIgnoreCase( "chaos hammer" ) |
				  s.equalsIgnoreCase( "circle of doom" ) | s.equalsIgnoreCase( "desecrate" ) |
				  s.equalsIgnoreCase( "healing circle" ) | s.equalsIgnoreCase( "holy smite" ) |
				  s.equalsIgnoreCase( "ice storm" ) | s.equalsIgnoreCase( "leomund's tiny hut" ) |
				  s.equalsIgnoreCase( "holy aura" ) | s.equalsIgnoreCase( "unholy aura" ) |
				  s.equalsIgnoreCase( "unholy blight" ) |s.equalsIgnoreCase( "web" ) ) {
			result = 4;
		}
		else if ( s.equalsIgnoreCase( "alarm" ) ) {
			result = 5;
		}
		else if ( s.equalsIgnoreCase( "blade barrier" ) | s.equalsIgnoreCase( "blasphemy" ) |
				  s.equalsIgnoreCase( "chain lightning" ) | s.equalsIgnoreCase( "dictum" ) |
				  s.equalsIgnoreCase( "dispel magic" ) | s.equalsIgnoreCase( "fog cloud" ) |
				  s.equalsIgnoreCase( "holy word" ) | s.equalsIgnoreCase( "solid fog" ) |
				  s.equalsIgnoreCase( "mordenkainen's disjunction" )|
				  s.equalsIgnoreCase( "stinking cloud" ) |
				  s.equalsIgnoreCase( "wail of the banshee" ) |
				  s.equalsIgnoreCase( "word of chaos" ) ) {
			result = 6;
		}
		else if ( s.equalsIgnoreCase( "entangle" ) ) {
			result = 8;
		}
		else if ( s.equalsIgnoreCase( "bane" ) | s.equalsIgnoreCase( "bless" ) |
				  s.equalsIgnoreCase( "circle of death" ) | s.equalsIgnoreCase( "sleet storm" ) ) {
			result = 10;
		}
		else if ( s.equalsIgnoreCase( "insect plague" ) ) {
			result = 18;
		}
		else if ( s.equalsIgnoreCase( "detect scrying" ) ) {
			result = 24;
		}
		else if ( s.equalsIgnoreCase( "storm of vengeance" ) ) {
			result = 72;
		}
		return result;
	}

/****************************************************************/

	public static Color calculateColor( String s ) {
		Color result = null;

		if ( s.equalsIgnoreCase( "stonetar" ) ) {
			/* A dirty, rosy brown color. */
			result = new Color( 139, 69, 19, 50 );
		}
		else if ( s.equalsIgnoreCase( "avienna's fog" ) | s.equalsIgnoreCase( "fog cloud" ) |
				  s.equalsIgnoreCase( "invisibility sphere" ) | s.equalsIgnoreCase( "silence" ) |
				  s.equalsIgnoreCase( "obscuring mist" ) | s.equalsIgnoreCase( "sleet storm" ) |
				  s.equalsIgnoreCase( "solid fog" ) | s.equalsIgnoreCase( "web " ) ) {
			result = new Color( Color.lightGray.getRed(),
								Color.lightGray.getGreen(),
								Color.lightGray.getBlue(), 75 );
		}
		else if ( s.equalsIgnoreCase( "thunderstone" ) | s.equalsIgnoreCase( "acid fog" ) |
				  s.equalsIgnoreCase( "insect plague" ) | s.equalsIgnoreCase( "mind fog" ) |
				  s.equalsIgnoreCase( "sound burst" ) | s.equalsIgnoreCase( "unholy aura" ) |
				  s.equalsIgnoreCase( "wail of the banshee" ) |
				  s.equalsIgnoreCase( "word of chaos" ) ) {
			result = new Color( Color.darkGray.getRed(),
								Color.darkGray.getGreen(),
								Color.darkGray.getBlue(), 50 );
		}
		else if ( s.equalsIgnoreCase( "tanglefoot bag" ) | s.equalsIgnoreCase( "entangle" ) |
				  s.equalsIgnoreCase( "repel vermin" )  | s.equalsIgnoreCase( "summon swarm" ) ) {
			result = new Color( Color.green.getRed(),
								Color.green.getGreen(),
								Color.green.getBlue(), 50 );
		}
		else if ( s.equalsIgnoreCase( "alchemist's fire" ) | s.equalsIgnoreCase( "fireball" ) |
				  s.equalsIgnoreCase( "faerie fire" ) | s.equalsIgnoreCase( "flame strike" ) |
				  s.equalsIgnoreCase( "incendiary cloud" ) ) {
			result = new Color( Color.orange.getRed(),
								Color.orange.getGreen(),
								Color.orange.getBlue(), 50 );
		}
		else if ( s.equalsIgnoreCase( "acid, flask" ) | s.equalsIgnoreCase( "chaos hammer" ) |
				  s.equalsIgnoreCase( "stinking cloud" ) | s.equalsIgnoreCase( "unholy blight" ) ) {
			result = new Color( Color.magenta.getRed(),
								Color.magenta.getGreen(),
								Color.magenta.getBlue(), 50 );
		}
		else if ( s.equalsIgnoreCase( "holy water" ) | s.equalsIgnoreCase( "dictum" ) |
				  s.equalsIgnoreCase( "dispel magic" ) | s.equalsIgnoreCase( "healing circle" ) |
				  s.equalsIgnoreCase( "holy smite" ) | s.equalsIgnoreCase( "holy word" ) |
				  s.equalsIgnoreCase( "teleportation circle" ) | s.equalsIgnoreCase( "holy aura" ) ) {
			result = new Color( Color.cyan.getRed(),
								Color.cyan.getGreen(),
								Color.cyan.getBlue(), 25 );
		}
		else if ( s.equalsIgnoreCase( "alarm" ) | s.equalsIgnoreCase( "prismatic sphere" ) |
				  s.equalsIgnoreCase( "rainbow pattern" ) | s.equalsIgnoreCase( "scare" ) |
				  s.equalsIgnoreCase( "storm of vengeance" ) ) {
			result = new Color( Color.red.getRed(),
								Color.red.getGreen(),
								Color.red.getBlue(), 50 );
		}
		else if ( s.equalsIgnoreCase( "antilife shell" ) | s.equalsIgnoreCase( "antiplant shell" ) |
				  s.equalsIgnoreCase( "antimagic field" ) | s.equalsIgnoreCase( "sleep" ) |
				  s.equalsIgnoreCase( "magic circle against ..." ) |
				  s.equalsIgnoreCase( "mordenkainen's disjunction" ) ) {
			/* A slate-blue color. */
			result = new Color( 106, 90, 205, 50 );
		}
		else if ( s.equalsIgnoreCase( "confusion" ) | s.equalsIgnoreCase( "detect scrying" ) ) {
			/* A misty-rose color. */
			result = new Color( 203, 185, 181, 100 );
		}
		else if ( s.equalsIgnoreCase( "bane" ) | s.equalsIgnoreCase( "blasphemy" ) |
				  s.equalsIgnoreCase( "bless" ) | s.equalsIgnoreCase( "circle of death" ) |
				  s.equalsIgnoreCase( "circle of doom" ) | s.equalsIgnoreCase( "desecrate" ) ) {
			/* A bisque color. */
			result = new Color( 139, 125, 107, 50 );
		}
		else if ( s.equalsIgnoreCase( "blade barrier" ) |
				  s.equalsIgnoreCase( "tenser's floating disk" ) ) {
			/* A light slate-grey color. */
			result = new Color( 119, 136, 153, 75 );
		}
		else if ( s.equalsIgnoreCase( "chain lightning" ) |
				  s.equalsIgnoreCase( "shatter" ) ) {
			/* A light steel-blue color. */
			result = new Color( 188, 210, 238, 50 );
		}
		else if ( s.equalsIgnoreCase( "cloudkill" ) ) {
			/* A green-yellow color. */
			result = new Color( 154, 205, 50, 50 );
		}
		else if ( s.equalsIgnoreCase( "ice storm" ) |
				  s.equalsIgnoreCase( "otiluke's freezing sphere" ) ) {
			result = new Color( Color.blue.getRed(),
								Color.blue.getGreen(),
								Color.blue.getBlue(), 15 );
		}
		else if ( s.equalsIgnoreCase( "leomund's tiny hut" ) ) {
			/* A saddle-brown color. */
			result = new Color( 139, 69, 19, 50 );
		}
		return result;
	}

/****************************************************************/
}