import java.util.Vector;
import java.util.Arrays;

public class GrenadeHandler {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private Vector grenadeSources = new Vector();
	private Vector grenadeNames = new Vector();

/****************************************************************/
/*	Constructors												*/
/****************************************************************/

	public GrenadeHandler() {
		loadgrenadeSources();
		loadgrenadeNames( grenadeSources );
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	public Vector getGrenadeSources() {
		return grenadeSources;
	}

	public Vector getGrenadeNames() {
		return grenadeNames;
	}

	/* Returns true iff the argument is a registered grenade. */
	public boolean isGrenade( String s ) {
		if ( grenadeNames.contains( s ) ) {
			return true;
		}
		return false;
	}

/****************************************************************/
/*	Methods														*/
/****************************************************************/

	private void loadgrenadeSources() {

		Grenade holyWater = new Grenade( "Holy water" );
		Grenade acid = new Grenade( "Acid, flask" );
		Grenade fog = new Grenade( "Avienna's fog" );
		Grenade stonetar = new Grenade( "Stonetar" );
		Grenade tangle = new Grenade( "Tanglefoot bag" );
		Grenade thunderstone = new Grenade( "Thunderstone" );
		Grenade fire = new Grenade( "Alchemist's Fire" );

		grenadeSources.add( acid );
		grenadeSources.add( fire );
		grenadeSources.add( fog );
		grenadeSources.add( holyWater );
		grenadeSources.add( stonetar );
		grenadeSources.add( tangle );
		grenadeSources.add( thunderstone );
		grenadeSources.trimToSize();
	}

/****************************************************************/

	private void loadgrenadeNames( Vector v ) {
		int size = v.size();
		for ( int i = 0; i < size; i++ ) {
			Grenade temp = ( Grenade ) v.elementAt( i );
			grenadeNames.add( temp.getName() );
		}
		grenadeNames.trimToSize();
	}

/****************************************************************/
}