import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.EtchedBorder;
import java.util.Vector;

public class HeightControl_GUI extends JPanel {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private JComboBox feet, inches;
	private JLabel feet_l, inches_l;

/****************************************************************/
/*	Constructor													*/
/****************************************************************/

	public HeightControl_GUI() {

		feet = makeFeetComboBox();
		inches = makeInchesComboBox();

		feet_l = makeFeetLabel();
		inches_l = makeInchesLabel();

		/* Setup look & feel of this panel. */
		this.setBorder( new EtchedBorder() );
		this.setLayout( new GridLayout( 2, 2 ) );
		this.add( feet_l );
		this.add( inches_l );
		this.add( feet );
		this.add( inches );
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	public int getFeetMeasurement() {
		return ( ( Integer ) feet.getSelectedItem() ).intValue();
	}

	public int getInchMeasurement() {
		return ( ( Integer ) inches.getSelectedItem() ).intValue();
	}

	public void setFeetMeasurement( int i ) {
		feet.setSelectedItem( new Integer( i ) );
	}

	public void setInchMeasurement( int i ) {
		inches.setSelectedItem( new Integer( i ) );
	}

	public void clear() {
		feet.setSelectedIndex( 5 );
		inches.setSelectedIndex( 0 );
	}

	public void enable() {
		feet.setEnabled( true );
		inches.setEnabled( true );
	}

	public void disable() {
		feet.setEnabled( false );
		inches.setEnabled( false );
	}

/****************************************************************/
/*	Methods														*/
/****************************************************************/

	/* Convenience method for making the combobox that controls
	 * the feet height denominator.
	 */
	public JComboBox makeFeetComboBox() {
		JComboBox result = new JComboBox();

		for ( int i = 1; i <= 1000; i++ ) {
			result.addItem( new Integer( i ) );
		}
		result.setEditable( false );
		result.setEnabled( true );
		result.setSelectedIndex( 5 );
		return result;
	}

/****************************************************************/

	/* Convenience method for making the combobox that controls the
	 * inches height denominator.
	 */
	public JComboBox makeInchesComboBox() {
		JComboBox result = new JComboBox();

		for ( int i = 0; i <= 12; i++ ) {
			result.addItem( new Integer( i ) );
		}
		result.setEditable( false );
		result.setEnabled( true );
		result.setSelectedIndex( 0 );
		return result;
	}

/****************************************************************/

	/* Convenience method for making the label for the feet denominator
	 * control box.
	 */
	public JLabel makeFeetLabel() {
		JLabel result = new JLabel( "Feet" );
		result.setHorizontalAlignment( JTextField.CENTER );
		return result;
	}

/****************************************************************/

	/* Convenience method for making the label for the inches denominator
	 * control box.
	 */
	public JLabel makeInchesLabel() {
		JLabel result = new JLabel( "Inches" );
		result.setHorizontalAlignment( JTextField.CENTER );
		return result;
	}
}