import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import java.util.Vector;

public class JumpSelector_GUI extends JPanel {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private JRadioButton runJump, standJump, runHiJump, standHiJump, jumpBack;
	private ButtonGroup jumpSelectorGroup;

/****************************************************************/
/*	Constructor													*/
/****************************************************************/

	public JumpSelector_GUI() {

		runJump = new JRadioButton( "Running jump" );
		standJump = new JRadioButton( "Standing jump" );
		runHiJump = new JRadioButton( "Running high jump" );
		standHiJump = new JRadioButton( "Standing high jump" );
		jumpBack = new JRadioButton( "Jump back" );

		jumpSelectorGroup = new ButtonGroup();
		jumpSelectorGroup.add( runJump );
		jumpSelectorGroup.add( standJump );
		jumpSelectorGroup.add( runHiJump );
		jumpSelectorGroup.add( standHiJump );
		jumpSelectorGroup.add( jumpBack );

		this.setBorder( new TitledBorder( new EtchedBorder(), "Jump Types" ) );
		this.setLayout( new FlowLayout() );
		this.add( runJump );
		this.add( standJump );
		this.add( runHiJump );
		this.add( standHiJump );
		this.add( jumpBack );
		runJump.setSelected( true );
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	public void clear() {
		runJump.setSelected( true );
	}

	public void setSelectedButton( int index ) {
		switch( index ) {
			case 0:
				runJump.setSelected( true );
				break;
			case 1:
				standJump.setSelected( true );
				break;
			case 2:
				runHiJump.setSelected( true );
				break;
			case 3:
				standHiJump.setSelected( true );
				break;
			case 4:
				jumpBack.setSelected( true );
				break;
			default:
				runJump.setSelected( true );
				break;
		}
	}

	public String getSelectedButton() {
		if ( runJump.isSelected() ) {
			return runJump.getText();
		}
		else if ( standJump.isSelected() ) {
			return standJump.getText();
		}
		else if ( runHiJump.isSelected() ) {
			return runHiJump.getText();
		}
		else if ( standHiJump.isSelected() ) {
			return standHiJump.getText();
		}
		else {
			return jumpBack.getText();
		}
	}
}
