import java.io.Serializable;
import java.awt.Point;
import java.awt.Rectangle;

public class Light implements Serializable {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private String name, duration;
	private int range;
	private Point location;
	private Rectangle boundingBox;
	private int id = 0;

/****************************************************************/
/*	Constructors												*/
/****************************************************************/

	public Light( String sourceName ) {
		name = sourceName;
		range = calculateRange( name )/5;
		duration = calculateDuration( name );
		id = Application.generateId();
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	public void setBoundingBox( Rectangle r ) {
		boundingBox = r;
	}

	public void setName( String s ) {
		name = s;
	}

	public void setRange( int i ) {
		range = i;
	}

	public void setDuration( String s ) {
		duration = s;
	}

	public void setLocation( Point p ) {
		location = p;
	}

	public String getName() {
		return name;
	}

	public int getRange() {
		return range;
	}

	public String getDuration() {
		return duration;
	}

	public Point getLocation() {
		return location;
	}

	public Rectangle getBoundingBox() {
		return boundingBox;
	}

	public int getId() {
		return id;
	}

/****************************************************************/
/*	Methods														*/
/****************************************************************/

	private int calculateRange( String s ) {
		if ( s.equalsIgnoreCase( "Candle" ) ) {
			return 5;
		}
		else if ( s.equalsIgnoreCase( "Lamp, common" ) ) {
			return 15;
		}
		else if ( s.equalsIgnoreCase( "Lantern, bullseye" ) ) {
			return 60;
		}
		else if ( s.equalsIgnoreCase( "Lantern, hooded" ) ) {
			return 30;
		}
		else if ( s.equalsIgnoreCase( "Sunrod" ) ) {
			return 30;
		}
		else if ( s.equalsIgnoreCase( "Torch" ) ) {
			return 20;
		}
		else if ( s.equalsIgnoreCase( "Continual Flame" ) ) {
			return 20;
		}
		else if ( s.equalsIgnoreCase( "Dancing Lights" ) ) {
			return 20;
		}
		else if ( s.equalsIgnoreCase( "Daylight" ) ) {
			return 60;
		}
		else if ( s.equalsIgnoreCase( "Light" ) ) {
			return 20;
		}
		else if ( s.equalsIgnoreCase( "Darkness" ) ) {
			return 20;
		}
		else if ( s.equalsIgnoreCase( "Deeper Darkness" ) ) {
			return 60;
		}
		return 0; // Default value
	}

/****************************************************************/

	private String calculateDuration( String s ) {
		if ( s.equalsIgnoreCase( "Candle" ) ) {
			return "1 hr.";
		}
		else if ( s.equalsIgnoreCase( "Lamp, common" ) ) {
			return "6 hr./pint";
		}
		else if ( s.equalsIgnoreCase( "Lantern, bullseye" ) ) {
			return "6 hr./pint";
		}
		else if ( s.equalsIgnoreCase( "Lantern, hooded" ) ) {
			return "6 hr./pint";
		}
		else if ( s.equalsIgnoreCase( "Sunrod" ) ) {
			return "6 hr.";
		}
		else if ( s.equalsIgnoreCase( "Torch" ) ) {
			return "1 hr.";
		}
		else if ( s.equalsIgnoreCase( "Continual Flame" ) ) {
			return "Permanent";
		}
		else if ( s.equalsIgnoreCase( "Dancing Lights" ) ) {
			return "1 mins.";
		}
		else if ( s.equalsIgnoreCase( "Daylight" ) ) {
			return "30 mins.";
		}
		else if ( s.equalsIgnoreCase( "Light" ) ) {
			return "10 mins.";
		}
		else if ( s.equalsIgnoreCase( "Darkness" ) ) {
			return "10 mins.";
		}
		else if ( s.equalsIgnoreCase( "Deeper Darkness" ) ) {
			return "30 mins.";
		}
		return "NA"; // Default value
	}

/****************************************************************/
}