import java.util.Vector;
import java.util.Arrays;

public class LightHandler {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private Vector lightSources = new Vector();
	private Vector lightNames = new Vector();

/****************************************************************/
/*	Constructors												*/
/****************************************************************/

	public LightHandler() {
		loadLightSources();
		loadLightNames( lightSources );
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	public Vector getLightSources() {
		return lightSources;
	}

	public Vector getLightNames() {
		return lightNames;
	}

/****************************************************************/
/*	Methods														*/
/****************************************************************/

	private void loadLightSources() {

		Light candle = new Light( "Candle" );
		Light commonLamp = new Light( "Lamp, common" );
		Light bullseyeLantern = new Light( "Lantern, bullseye" );
		Light hoodedLantern = new Light( "Lantern, hooded" );
		Light sunrod = new Light( "Sunrod" );
		Light torch = new Light( "Torch" );
		Light continualFlame = new Light( "Continual Flame" );
		Light dancingLights = new Light( "Dancing Lights" );
		Light daylight = new Light( "Daylight" );
		Light light = new Light( "Light" );
		Light darkness = new Light( "Darkness" );
		Light ddark = new Light( "Deeper Darkness" );

		lightSources.add( candle );
		lightSources.add( continualFlame );
		lightSources.add( commonLamp );
		lightSources.add( dancingLights );
		lightSources.add( darkness );
		lightSources.add( daylight );
		lightSources.add( ddark );
		lightSources.add( bullseyeLantern );
		lightSources.add( hoodedLantern );
		lightSources.add( light );
		lightSources.add( sunrod );
		lightSources.add( torch );
		lightSources.trimToSize();
	}

/****************************************************************/

	private void loadLightNames( Vector v ) {
		int size = v.size();
		for ( int i = 0; i < size; i++ ) {
			Light temp = ( Light ) v.elementAt( i );
			lightNames.add( temp.getName() );
		}
		lightNames.trimToSize();
	}

/****************************************************************/
}