import java.util.Vector;
import FileSorter;

public class MagicMishapTable {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private Vector mishapVector = new Vector();
	private FileSorter fileSorter;

/****************************************************************/
/*	Constructor													*/
/****************************************************************/

	public MagicMishapTable( FileSorter fs ) {
		fileSorter = fs;
		mishapVector = fs.read( Application.mishapFile, "Text" );
		mishapVector.trimToSize();
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	/* Returns the whole vector of valid mishaps. */
	public Vector getMishapVector() {
		return mishapVector;
	}

/****************************************************************/

	/* Returns the size of the vector. */
	public int getMishapVectorSize() {
		return mishapVector.size();
	}

/****************************************************************/

	/* Returns an element at the specified position. */
	public String getMishapAt( int index ) {
		return ( String ) mishapVector.elementAt( index );
	}

/****************************************************************/

	/* Adds an element to the vector. */
	public void addMishap( String data ) {
		if ( !mishapVector.contains( data ) ) {
			mishapVector.add( data );
		}
	}

/****************************************************************/

	/* Adds an element to the specified position in the vector. */
	public void addMishapAt( String data, int index ) {
		if ( !mishapVector.contains( data ) ) {
			mishapVector.add( index, data );
		}
	}

/****************************************************************/

	/* Deletes the element from the vector. */
	public void removeMishap( String data ) {
		if ( mishapVector.contains( data ) ) {
			mishapVector.removeElement( data );
		}
	}

/****************************************************************/

	/* Deletes the element at the specified position from the vector. */
	public void removeMishapAt( int index ) {
		mishapVector.removeElementAt( index );
	}
}