import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.EtchedBorder;
import MagicMishapTable;

public class MagicMishapTable_GUI extends JPanel implements ActionListener {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private MagicMishapTable mmt;
	private double maxSize = 0.0;

	private JButton generate, massGenerate, clear;
	private JTextArea magicMishapDisplay;

	private final int massGenerateMax = 10;

/****************************************************************/
/*	Constructors												*/
/****************************************************************/

	public MagicMishapTable_GUI( MagicMishapTable input ) {

		mmt = input;
		maxSize = ( double ) mmt.getMishapVectorSize();

		magicMishapDisplay = new JTextArea();
		magicMishapDisplay.setEditable( false );
		magicMishapDisplay.setLineWrap( true );
		JScrollPane jsp = new JScrollPane( magicMishapDisplay );

		generate = new JButton( "Generate magic mishap" );
		generate.addActionListener( this );
		massGenerate = new JButton( "Generate 10 magic mishaps" );
		massGenerate.addActionListener( this );
		clear = new JButton( "Clear" );
		clear.addActionListener( this );

		JPanel southPanel = new JPanel();
		southPanel.setLayout( new GridLayout( 3, 1 ) );
		southPanel.add( generate );
		southPanel.add( massGenerate );
		southPanel.add( clear );

		this.setBorder( new EtchedBorder() );
		this.setLayout( new BorderLayout() );
		this.add( jsp, BorderLayout.CENTER );
		this.add( southPanel, BorderLayout.SOUTH );
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	public void setDisplayText( String s ) {
		magicMishapDisplay.append( s );
	}

/****************************************************************/

	public void clearAll() {
		magicMishapDisplay.setText( "" );
	}

/****************************************************************/
/*	Methods														*/
/****************************************************************/

	/* Returns a randomly generated int primitive, used to select
	 * the magic mishap.
	 */
	public int getMishap() {
		double seed = Math.random() * maxSize;
		return ( int ) seed;
	}

/****************************************************************/
/*	Action Listeners											*/
/****************************************************************/

	public void actionPerformed( ActionEvent ae ) {
		String result = "";

		if ( ae.getSource() == clear ) {
			clearAll();
		}
		else if ( ae.getSource() == massGenerate ) {
			for ( int i = 0; i < massGenerateMax; i++ ) {
				result += mmt.getMishapAt( getMishap() ) + "\n\n";
			}
			setDisplayText( result );
		}
		else {
			result = mmt.getMishapAt( getMishap() ) + "\n\n";
			setDisplayText( result );
		}
	}
}