import java.awt.Rectangle;
import java.awt.Color;
import java.awt.Point;
import java.util.StringTokenizer;
import java.util.Random;
import java.util.Calendar;
import java.io.Serializable;
import Character;

public class Marker implements Serializable {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private Character character;
	private int id;

	private Color holderColor;
	private Rectangle boundingBox;

/****************************************************************/
/*	Constructors												*/
/****************************************************************/

	public Marker( int h, int a, int i, int z, int m,
				   String n, String w, int am, String d,
				   String s, String ls, int mm, int rm, int dm,
				   String spe, boolean f ) {

		character = new Character( h, a, i, z, m, n, w, am, d,
								   s, ls, mm, rm, dm, spe );
		id = generateId();

		if ( f ) holderColor = Color.green;
		else holderColor = Color.red;
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	public Rectangle getBoundingBox() {
		return boundingBox;
	}

	public String getActiveSpell() {
		return character.getSpell();
	}

	public int getMeleeMod() {
		return character.getMeleeMod();
	}

	public int getRangeMod() {
		return character.getRangeMod();
	}

	public int getDmgMod() {
		return character.getDmgMod();
	}

	public int getDistanceMoved() {
		return character.getDistanceMoved();
	}

	public String getLightSource() {
		return character.getLightSource();
	}

	public int getLightRange() {
		return character.getLightRange();
	}

	public String getStatus() {
		return character.getStatus();
	}

	public String getSize() {
		return character.getSize();
	}

	public boolean getRangeWeapon() {
		return character.getRangeWeapon();
	}

	public boolean getReachWeapon() {
		return character.getReachWeapon();
	}

	public int getRangeIncrement() {
		return character.getRangeIncrement();
	}

	public int getId() {
		return id;
	}

	public int getMoveLeft() {
		return ( character.getMoveLeft() );
	}

	public int getInitiative() {
		return character.getInitiative();
	}

	public float getInternalInitiative() {
		return character.getIntInit();
	}

	public int getHP() {
		return character.getHP();
	}

	public int getMove() {
		return ( character.getMove() );
	}

	public int getAC() {
		return character.getAC();
	}

	public int getWounds() {
		return character.getWounds();
	}

	public String getName() {
		return character.getName();
	}

	public String getWeapon() {
		return character.getWeapon();
	}

	public int getAmmo() {
		return character.getAmmo();
	}

	public String getDmg() {
		return character.getDmg();
	}

	public void setBoundingBox( Rectangle r ) {
		boundingBox = r;
	}

	public void setActiveSpell( String s ) {
		character.setSpell( s );
	}

	public void setAmmo( int i ) {
		character.setAmmo( i );
	}

	public void setAmmo( String s ) {
		character.setAmmo( ( new Integer( s ) ).intValue() );
	}

	public void setInitiative( int i ) {
		character.setInitiative( i );
	}

	public void setInternalInitiative( int i ) {
		character.setIntInit( i );
	}

	public void setInternalInitiative( float f ) {
		character.setIntInit( f );
	}

	public void setHP( int i ) {
		character.setHP( i );
	}

	public void setMove( int i ) {
		character.setMove( i );
	}

	public void setAC( int i ) {
		character.setAC( i );
	}

	public void setWounds( int i ) {
		character.setWounds( i );
	}

	public void setName( String s ) {
		character.setName( s );
	}

	public void setDmg( String s ) {
		character.setDmg( s );
	}

	public void setSize( String s ) {
		character.setSize( s );
	}

	public void setWeapon( String s ) {
		character.setWeapon( s );
	}

	public Color getMarkerColor() {
		return holderColor;
	}

	public void setMarkerColor( Color c ) {
		holderColor = c;
	}

	public void setLightSource( String s ) {
		character.setLightSource( s );
	}

	public void setDistanceMoved( int i ) {
		character.setDistanceMoved( i );
	}

	public void setMeleeMod( int i ) {
		character.setMeleeMod( i );
	}

	public void setRangeMod( int i ) {
		character.setRangeMod( i );
	}

	public void setDmgMod( int i ) {
		character.setDmgMod( i );
	}

	public boolean hasMoveLeft() {
		return character.hasMoveLeft();
	}

/****************************************************************/
/*	Methods														*/
/****************************************************************/

	private int generateId() {
		Calendar c = Calendar.getInstance();
		String generator = "" + c.get( Calendar.HOUR_OF_DAY ) +
					c.get( Calendar.MINUTE ) +
					c.get( Calendar.SECOND ) +
					c.get( Calendar.MILLISECOND );
		 return  ( new Integer( generator ) ).intValue();
	}

/****************************************************************/

	public void reCalculateAll() {
		character.reCalculateAll();
	}

/****************************************************************/
}