import javax.swing.*;
import javax.swing.border.EtchedBorder;
import java.awt.event.*;
import java.awt.*;

public class NumberSelectorBox extends JPanel implements ActionListener {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private JButton increment, decrement;
	private JTextField numberField;

/****************************************************************/
/*	Constructors												*/
/****************************************************************/

	public NumberSelectorBox() {
		/* Instantiate all components. */
		increment = new JButton( "Up" );
		decrement = new JButton( "Down" );
		numberField = new JTextField();
		numberField.setText( "0" );

		/* Cater for text alignment. */
		increment.setHorizontalAlignment( JTextField.CENTER );
		decrement.setHorizontalAlignment( JTextField.CENTER );
		numberField.setHorizontalAlignment( JTextField.CENTER );

		/* Add action listeners. */
		increment.addActionListener( this );
		decrement.addActionListener( this );

		/* Setup the look and feel of the main panel. */
		this.setLayout( new BorderLayout() );
		this.add( numberField, BorderLayout.CENTER );
		this.add( increment, BorderLayout.WEST );
		this.add( decrement, BorderLayout.EAST );
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	public int getNumberField() {
		int result = 0;

		try {
			String value = numberField.getText();
			result = ( new Integer( value ) ).intValue();
		}
		catch( NumberFormatException nfe ) {
			result = 0;
		}
		return result;
	}

	public void setNumberField( int i ) {
		numberField.setText( "" + i );
	}

	public void setNumberField( String s ) {
		numberField.setText( s );
	}

	public void disable() {
		increment.setEnabled( false );
		decrement.setEnabled( false );
		numberField.setEnabled( false );
	}

	public void enable() {
		increment.setEnabled( true );
		decrement.setEnabled( true );
		numberField.setEnabled( true );
	}

	public void clear() {
		numberField.setText( "0" );
	}

/****************************************************************/
/*	Action Listener												*/
/****************************************************************/

	public void actionPerformed( ActionEvent ae ) {
		int value = getNumberField();

		if ( ae.getSource() == increment ) {
			value += 1;
		}
		else {
			value -= 1;
		}
		setNumberField( value );
	}
}