import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.EtchedBorder;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import WeaponsHandler;
import SpellHandler;
import LightHandler;

public class OptionFrame extends JFrame implements WindowListener, ActionListener {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private GrenadeHandler grenadeHandler;
	private SpellHandler spellHandler;
	private LightHandler lightHandler;

	private JComboBox grenades, spells, lights;
	private JLabel grenade_l, spell_l, light_l;

	private JButton OK, cancel;

/****************************************************************/
/*	Constructors												*/
/****************************************************************/

	public OptionFrame( GrenadeHandler gh, SpellHandler sh, LightHandler lh  ) {

		/* Setup all the pointers. */
		grenadeHandler = gh;
		spellHandler = sh;
		lightHandler = lh;

		/* Setup the combo boxes. */
		grenades = new JComboBox( grenadeHandler.getGrenadeNames() );
		grenades.setEditable( false );
		grenades.setEnabled( true );
		grenades.addItem( "None" );
		grenades.setSelectedItem( "None" );
		lights = new JComboBox( lightHandler.getLightNames() );
		lights.setEditable( false );
		lights.setEnabled( true );
		lights.addItem( "None" );
		lights.setSelectedItem( "None" );
		spells = new JComboBox( spellHandler.getSpellNames() );
		spells = new JComboBox();
		spells.setEditable( false );
		spells.setEnabled( true );
		spells.addItem( "None" );
		spells.setSelectedItem( "None" );

		/* Setup the labels. */
		grenade_l = new JLabel( "Add a grenade" );
		spell_l = new JLabel( "Add a spell" );
		light_l = new JLabel( "Add a light" );

		/* Setup the buttons. */
		OK = new JButton( "OK" );
		cancel = new JButton( "Cancel" );
		OK.addActionListener( this );
		cancel.addActionListener( this );

		JPanel optionPanel = new JPanel();
		optionPanel.setLayout( new GridLayout( 2, 3 ) );
		optionPanel.add( grenade_l );
		optionPanel.add( light_l );
		optionPanel.add( spell_l );
		optionPanel.add( grenades );
		optionPanel.add( lights );
		optionPanel.add( spells );

		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout( new FlowLayout() );
		buttonPanel.add( OK );
		buttonPanel.add( cancel );

		JPanel contentPanel = new JPanel();
		contentPanel.setBorder( new EtchedBorder() );
		contentPanel.setLayout( new BorderLayout() );
		contentPanel.add( optionPanel, BorderLayout.CENTER );
		contentPanel.add( buttonPanel, BorderLayout.SOUTH );

		this.setTitle( "Add an effect" );
		this.addWindowListener( this );
		this.getContentPane().add( contentPanel );
		//this.setSize( 400, 200 );
		this.pack();
		this.setResizable( false );
		this.setVisible( false );
		repaint();
	}

/****************************************************************/
/*	Methods														*/
/****************************************************************/

	public void makeVisible() {
		this.setVisible( true );
	}

/****************************************************************/

	public void makeInvisible() {
		this.setVisible( false );
	}

/****************************************************************/

	public String[] getSelectedItems() {
		String[] selectedItems = new String[ 3 ];

		String selectedGrenade = ( String ) grenades.getSelectedItem();
		String selectedLight = ( String ) lights.getSelectedItem();
		String selectedSpell = ( String ) spells.getSelectedItem();

		if ( !selectedGrenade.equalsIgnoreCase( "None" ) ) {
			selectedItems[ 0 ] = selectedGrenade;
		}
		if ( !selectedLight.equalsIgnoreCase( "None" ) ) {
			selectedItems[ 1 ] = selectedLight;
		}
		if ( !selectedSpell.equalsIgnoreCase( "None" ) ) {
			selectedItems[ 2] = selectedSpell;
		}
		return selectedItems;
	}

	public void forcePaint() {
		this.repaint();
	}

/****************************************************************/
/*	Action Listeners											*/
/****************************************************************/

	public void actionPerformed( ActionEvent ae ) {

		if ( ae.getSource() == OK ) {

		}
		exitProgram();
	}

/****************************************************************/
/*	Window Listeners											*/
/****************************************************************/

	public void exitProgram() {
		this.setVisible( false );
	}

	public void kill() {
		this.dispose();
	}

	public void windowActivated( WindowEvent we ) {}
	public void windowDeactivated( WindowEvent we ) {}
	public void windowIconified( WindowEvent we ) {}
	public void windowDeiconified( WindowEvent we ) {}
	public void windowOpened( WindowEvent we ) {}
	public void windowClosed( WindowEvent we ) {}
	public void windowClosing( WindowEvent we ) {
		exitProgram();
	}
}