import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.EtchedBorder;
import java.util.Vector;
import java.util.StringTokenizer;
import Spell;
import SpellHandler;

public class SpellPanel extends JPanel implements ActionListener, ListSelectionListener {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private JPanel fieldsPanel;
	private JPanel buttonPanel;

	private JLabel spellName_l;
	private JLabel spellLevel_l;
	private JLabel spellSchool_l;
	private JLabel spellComponents_l;
	private JLabel spellCastTime_l;
	private JLabel spellRange_l;
	private JLabel spellDuration_l;
	private JLabel spellSave_l;
	private JLabel spellResist_l;
	private JLabel spellEffect_l;

	private JTextField spellName;
	private JTextField spellLevel;
	private JTextField spellSchool;
	private JTextField spellComponents;
	private JTextField spellCastTime;
	private JTextField spellRange;
	private JTextField spellDuration;
	private JTextField spellSave;
	private JTextField spellResist;
	private JTextField spellEffect;

	private JButton back, forward, home;
	private JList spellList;

	private Vector spellVector = new Vector();
	private Vector spellNames = new Vector();
	private SpellHandler spellHandler;

	private int currentIndex = 0;

/****************************************************************/
/*	Constructors												*/
/****************************************************************/

	public SpellPanel( SpellHandler sh ) {

		/* Setup all pointers. */
		spellHandler = sh;
		spellVector = sh.getSpells();
		spellNames = sh.getSpellNames();

		/* Setup the list. */
		spellList = new JList( spellNames );
		spellList.setFixedCellWidth( 200 );
		spellList.addListSelectionListener( this );

		/* Setup the buttons. */
		back = new JButton( "Previous" );
		back.addActionListener( this );
		home = new JButton( "Home" );
		home.addActionListener( this );
		forward = new JButton( "Next" );
		forward.addActionListener( this );

		/* Instantiate all components. */
		fieldsPanel = new JPanel();
		buttonPanel = new JPanel();
		spellName_l = new JLabel( "Name" );
		spellLevel_l = new JLabel( "Level" );
		spellSchool_l= new JLabel( "School" );
		spellComponents_l= new JLabel( "Components" );
		spellCastTime_l= new JLabel( "Casting time" );
		spellRange_l= new JLabel( "Range" );
		spellDuration_l= new JLabel( "Duration" );
		spellSave_l= new JLabel( "Saving Throw" );
		spellResist_l= new JLabel( "Spell Resistance" );
		spellEffect_l= new JLabel( "Effect" );
		spellName = new JTextField();
		spellLevel = new JTextField();
		spellSchool = new JTextField();
		spellComponents = new JTextField();
		spellCastTime = new JTextField();
		spellRange = new JTextField();
		spellDuration = new JTextField();
		spellSave = new JTextField();
		spellResist = new JTextField();
		spellEffect = new JTextField();

		/* Setup text alignment for the textfields. */
		spellName.setHorizontalAlignment( JTextField.CENTER );
		spellLevel.setHorizontalAlignment( JTextField.CENTER );
		spellSchool.setHorizontalAlignment( JTextField.CENTER );
		spellComponents.setHorizontalAlignment( JTextField.CENTER );
		spellCastTime.setHorizontalAlignment( JTextField.CENTER );
		spellRange.setHorizontalAlignment( JTextField.CENTER );
		spellDuration.setHorizontalAlignment( JTextField.CENTER );
		spellSave.setHorizontalAlignment( JTextField.CENTER );
		spellResist.setHorizontalAlignment( JTextField.CENTER );
		spellEffect.setHorizontalAlignment( JTextField.CENTER );

		/* Disable editing of the textfields. */
		spellName.setEditable( false );
		spellLevel.setEditable( false );
		spellSchool.setEditable( false );
		spellComponents.setEditable( false );
		spellCastTime.setEditable( false );
		spellRange.setEditable( false );
		spellDuration.setEditable( false );
		spellSave.setEditable( false );
		spellResist.setEditable( false );
		spellEffect.setEditable( false );

		/* Setup fields panel appearance. */
		fieldsPanel.setBorder( new EtchedBorder() );
		fieldsPanel.setLayout( new GridLayout( 20, 1 ) );
		fieldsPanel.add( spellName_l );
		fieldsPanel.add( spellName );
		fieldsPanel.add( spellLevel_l );
		fieldsPanel.add( spellLevel );
		fieldsPanel.add( spellSchool_l );
		fieldsPanel.add( spellSchool );
		fieldsPanel.add( spellComponents_l );
		fieldsPanel.add( spellComponents );
		fieldsPanel.add( spellCastTime_l );
		fieldsPanel.add( spellCastTime );
		fieldsPanel.add( spellRange_l );
		fieldsPanel.add( spellRange );
		fieldsPanel.add( spellDuration_l );
		fieldsPanel.add( spellDuration );
		fieldsPanel.add( spellSave_l );
		fieldsPanel.add( spellSave );
		fieldsPanel.add( spellResist_l );
		fieldsPanel.add( spellResist );
		fieldsPanel.add( spellEffect_l );
		fieldsPanel.add( spellEffect );

		/* Setup button panel. */
		buttonPanel.setBorder( new EtchedBorder() );
		buttonPanel.setLayout( new FlowLayout() );
		buttonPanel.add( back );
		buttonPanel.add( home );
		buttonPanel.add( forward );

		/* Setup scrolling for the list. */
		JScrollPane jsp = new JScrollPane( spellList );

		/* Setup main panel appearance. */
		this.setBorder( new EtchedBorder() );
		this.setLayout( new BorderLayout() );
		this.add( fieldsPanel, BorderLayout.CENTER );
		this.add( buttonPanel, BorderLayout.SOUTH );
		this.add( jsp, BorderLayout.WEST );
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	public Vector getSpellNames() {
		return spellHandler.getSpellNames();
	}

	public void setName( String s ) {
		spellName.setText( s );
	}

	public void setLevel( String s ) {
		spellLevel.setText( s );
	}

	public void setSchool( String s ) {
		spellSchool.setText( s );
	}

	public void setComponents( String s ) {
		spellComponents.setText( s );
	}

	public void setCastTime( String s ) {
		spellCastTime.setText( s );
	}

	public void setRange( String s ) {
		spellRange.setText( s );
	}

	public void setDuration( String s ) {
		spellDuration.setText( s );
	}

	public void setSave( String s ) {
		spellSave.setText( s );
	}

	public void setResist( String s ) {
		spellResist.setText( s );
	}

	public void setEffect( String s ) {
		spellEffect.setText( s );
	}

	public void setAllBlank() {
		setName( "" );
		setLevel( "" );
		setSchool( "" );
		setComponents( "" );
		setCastTime( "" );
		setRange( "" );
		setDuration( "" );
		setSave( "" );
		setResist( "" );
		setEffect( "" );
	}

/****************************************************************/
/*	Methods														*/
/****************************************************************/

	public void displayItemAt( int i ) {
		try {
			Spell temp = ( Spell ) spellVector.elementAt( i );

			if ( temp != null ) {
				setName( temp.getSpellName() );
				setLevel( temp.getSpellLevel() );
				setSchool( temp.getSpellSchool() );
				setComponents( temp.getSpellComponents() );
				setCastTime( temp.getSpellCastTime() );
				setRange( temp.getSpellRange() );
				setDuration( temp.getSpellDuration() );
				setSave( temp.getSpellSave() );
				setResist( temp.getSpellResist() );
				setEffect( temp.getSpellEffect() );
			}
		}
		catch( ArrayIndexOutOfBoundsException aioobe ) {
			/* This exception indicates that the spell was not found.
			 * Most probably due to the "none" weapon selected in
			 * the GUI.
			 */
			setAllBlank();
		}
	}

/****************************************************************/
/*	Action Listener												*/
/****************************************************************/

	public void actionPerformed( ActionEvent ae ) {
		if ( ae.getSource() == back ) {
			currentIndex -= 1;
		}
		else if ( ae.getSource() == forward ) {
			currentIndex += 1;
		}
		else {
			currentIndex = 0;
		}
		displayItemAt( currentIndex );
		spellList.setSelectedIndex( currentIndex );
	}

/****************************************************************/
/*	ListSelection Listener										*/
/****************************************************************/

	public void valueChanged( ListSelectionEvent lse ) {
		try {
			currentIndex = spellList.getSelectedIndex();
			displayItemAt( currentIndex );
		}
		catch( ArrayIndexOutOfBoundsException aioobe ) {

		}
	}
}