import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.EtchedBorder;
import java.util.Vector;
import java.util.StringTokenizer;
import Weapon;
import WeaponsHandler;

public class WeaponsPanel extends JPanel {

/****************************************************************/
/*	Declarations						*/
/****************************************************************/

	private JPanel fieldsPanel;
	private JLabel weaponName_l;
	private JLabel weaponDmg_l;
	private JLabel weaponCritical_l;
	private JLabel weaponCriticalDmg_l;
	private JLabel dmgType_l;
	private JTextField weaponName;
	private JTextField weaponDmg;
	private JTextField weaponCritical;
	private JTextField weaponCriticalDmg;
	private JTextField dmgType;
	private Vector weaponsVector = new Vector();
	private WeaponsHandler weaponsHandler;

/****************************************************************/
/*	Constructors						*/
/****************************************************************/

	public WeaponsPanel( WeaponsHandler wh ) {

		/* Setup all pointers. */
		weaponsHandler = wh;
		weaponsVector = wh.getWeapons();

		/* Instantiate all components. */
		fieldsPanel = new JPanel();
		weaponName_l = new JLabel( "Weapon name" );
		weaponDmg_l = new JLabel( "Damage range" );
		weaponCritical_l = new JLabel( "Critical threat range" );
		weaponCriticalDmg_l = new JLabel( "Critical bonus damage" );
		dmgType_l = new JLabel( "Damage type" );
		weaponName = new JTextField();
		weaponName.setEditable( false );
		weaponDmg = new JTextField();
		weaponDmg.setEditable( false );
		weaponCritical = new JTextField();
		weaponCritical.setEditable( false );
		weaponCriticalDmg = new JTextField();
		weaponCriticalDmg.setEditable( false );
		dmgType = new JTextField();
		dmgType.setEditable( false );

		/* Set textfield justifications. */
		weaponName.setHorizontalAlignment( JTextField.CENTER );
		weaponDmg.setHorizontalAlignment( JTextField.CENTER );
		weaponCritical.setHorizontalAlignment( JTextField.CENTER );
		weaponCriticalDmg.setHorizontalAlignment( JTextField.CENTER );
		dmgType.setHorizontalAlignment( JTextField.CENTER );

		/* Setup fields panel appearance. */
		fieldsPanel.setBorder( new EtchedBorder() );
		fieldsPanel.setLayout( new GridLayout( 10, 1 ) );
		fieldsPanel.add( weaponName_l );
		fieldsPanel.add( weaponName );
		fieldsPanel.add( weaponDmg_l );
		fieldsPanel.add( weaponDmg );
		fieldsPanel.add( weaponCritical_l );
		fieldsPanel.add( weaponCritical );
		fieldsPanel.add( weaponCriticalDmg_l );
		fieldsPanel.add( weaponCriticalDmg );
		fieldsPanel.add( dmgType_l );
		fieldsPanel.add( dmgType );

		/* Setup main panel appearance. */
		this.setBorder( new EtchedBorder() );
		this.setLayout( new BorderLayout() );
		this.add( fieldsPanel, BorderLayout.CENTER );
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	public Vector getWeaponNames() {
		return weaponsHandler.getWeaponsNames();
	}

	public void setWeaponName( String s ) {
		weaponName.setText( s );
	}

	public void setWeaponDmg( String s ) {
		weaponDmg.setText( s );
	}

	public void setWeaponCritical( String s ) {
		weaponCritical.setText( s );
	}

	public void setWeaponCriticalDmg( String s ) {
		weaponCriticalDmg.setText( s );
	}

	public void setDmgType( String s ) {
		dmgType.setText( s );
	}

	public void displayItemAt( int i ) {
		try {
			Weapon temp = ( Weapon ) weaponsVector.elementAt( i );

			if ( temp != null ) {
				setWeaponName( temp.getName() );
				setWeaponDmg( temp.getDmg() );
				setWeaponCritical( temp.getCritThreat() );
				setWeaponCriticalDmg( temp.getCritical() );
				setDmgType( temp.getDmgType() );
			}
		}
		catch( ArrayIndexOutOfBoundsException aioobe ) {
			/* This exception indicates that the weapon was not found.
			 * Most probably due to the "none" weapon selected in
			 * the GUI.
			 */
			setWeaponName( "" );
			setWeaponDmg( "" );
			setWeaponCritical( "" );
			setWeaponCriticalDmg( "" );
			setDmgType( "" );
		}
	}
}