import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import XPTable;

public class XPTable_GUI extends JPanel implements ActionListener {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private XPTable xpt = new XPTable();
	private JPanel display;
	private	JPanel buttons;
	private	JTextField partyLevel;
	private	JTextField challengeRating;
	private	JTextField numberOfPlayers;
	private	JTextField totalXPEarned;
	private	JTextField XPPerPlayer;
	private	JLabel partyLevelLabel;
	private	JLabel challengeRatingLabel;
	private	JLabel numberOfPlayersLabel;
	private	JLabel totalXPEarnedLabel;
	private	JLabel XPPerPlayerLabel;
	private	JButton activate;
	private	JButton clear;

/****************************************************************/
/*	Constructors												*/
/****************************************************************/

	public XPTable_GUI() {

		/* Instantiate all components. */
		display = new JPanel();
		buttons = new JPanel();
		partyLevel = new JTextField();
		challengeRating = new JTextField();
		numberOfPlayers = new JTextField();
		totalXPEarned = new JTextField();
		XPPerPlayer = new JTextField();
		partyLevelLabel = new JLabel( "Average party level" );
		challengeRatingLabel = new JLabel( "Encounter challenge rating" );
		numberOfPlayersLabel = new JLabel( "Number of players" );
		totalXPEarnedLabel = new JLabel( "Total XP gained" );
		XPPerPlayerLabel = new JLabel( "XP gained per player" );
		activate = new JButton( "Calculate XP" );
		clear = new JButton( "Clear" );

		/* Add components to panel. */
		display.setBorder( new EtchedBorder() );
		display.setLayout( new GridLayout( 5, 2 ) );
		display.add( partyLevelLabel );
		display.add( partyLevel );
		display.add( challengeRatingLabel );
		display.add( challengeRating );
		display.add( numberOfPlayersLabel );
		display.add( numberOfPlayers );
		display.add( totalXPEarnedLabel );
		display.add( totalXPEarned );
		display.add( XPPerPlayerLabel );
		display.add( XPPerPlayer );
		buttons.setBorder( new EtchedBorder() );
		buttons.setLayout( new GridLayout( 2, 1 ) );
		buttons.add( activate );
		buttons.add( clear );

		/* Activate the button. */
		activate.addActionListener( this );
		clear.addActionListener( this );

		/* Setup the GUI layout. */
		this.setBorder( new TitledBorder( new EtchedBorder(), "XP Calculator" ) );
		this.setLayout( new BorderLayout() );
		this.add( display, BorderLayout.CENTER );
		this.add( buttons, BorderLayout.SOUTH );
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	/* Returns the underlying XP table. */
	public XPTable getXPTable() {
		return xpt;
	}

/****************************************************************/
/*	Action Listener												*/
/****************************************************************/

	public void actionPerformed( ActionEvent ae ) {

		int plr = 0;
		int cr = 0;
		int np = 0;
		int totalXP = 0;
		int XPperplayer = 0;

		if ( ae.getSource() == activate ) {

			String plr_s = partyLevel.getText();
			String cr_s = challengeRating.getText();
			String np_s = numberOfPlayers.getText();

			if ( plr_s.length() > 0 ) {
				plr = new Integer( plr_s ).intValue();
			}
			else {
				plr = 1;
				partyLevel.setText( "" + plr );
			}

			if ( cr_s.length() > 0 ) {
				cr = new Integer( cr_s ).intValue();
			}
			else {
				cr = 1;
				challengeRating.setText( "" + cr );
			}

			if ( np_s.length() > 0 ) {
				np = new Integer( np_s ).intValue();
			}
			else {
				np = 1;
				numberOfPlayers.setText( "" + np );
			}

			totalXP = xpt.calculateTotalXP( plr, cr );
			XPperplayer = xpt.calculatePlayerXP( plr, cr, np );

			totalXPEarned.setText( "" + totalXP );
			XPPerPlayer.setText( "" + XPperplayer );
		}
		else {
			partyLevel.setText( "" );
			challengeRating.setText( "" );
			numberOfPlayers.setText( "" );
			totalXPEarned.setText( "" );
			XPPerPlayer.setText( "" );
			partyLevel.requestFocus();
		}
	}
}